(*
   kisten version 1.2  Copyright (C) 1989-2004 Frank Reglin

   kisten is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   kisten is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with kisten; see the file COPYING.
*)
program makedat;
(* erzeugt Datenfile fuer KISTEN *)

label 1;

const
  maxebene = 50;
  inp = 'ebenen.txt';
  outp= 'kisten.dat';

type
  feldspeicher = array[1..19,0..2] of integer;

var
  sf : text;
  df : file of feldspeicher;
  c : char;
  n,x,y,a,k : integer;
  s : array[1..16,1..19] of char;
  d : feldspeicher;
  p2:array[1..16] of integer;

begin
  p2[ 1]:= 1;    p2[ 2]:= 2;    p2[ 3]:= 4;    p2[ 4]:= 8;
  p2[ 5]:=$10;   p2[ 6]:=$20;   p2[ 7]:=$40;   p2[ 8]:=$80;
  p2[ 9]:=$100;  p2[10]:=$200;  p2[11]:=$400;  p2[12]:=$800;
  p2[13]:=$1000; p2[14]:=$2000; p2[15]:=$4000; p2[16]:=p2[15] * 2;
  assign(sf,inp);
  assign(df,outp);
  reset(sf);
  rewrite(df);
  writeln(inp,' --> ',outp);
  for k:=1 to maxebene do write(df,d);
  reset(df);
  writeln(maxebene:3,' leere Dateisaetze erzeugt');
  k:=0;
  while not eof(sf) do
  begin
    repeat
      if eof(sf) then goto 1;
      read(sf,c);
      if c=':' then  readln(sf,n);
    until c=':';
    k:=k+1;
    write(chr(13),' (',k:2,')    Ebene',n:4);
    for y:=1 to 16 do
    begin
      repeat
        read(sf,c)
      until c='.';
      for x:=1 to 19 do  read(sf,s[y,x]);
      readln(sf)
    end;
    for x:=1 to 19 do
    begin
      d[x,2]:=0; d[x,1]:=0; d[x,0]:=0;
      for y:=1 to 16 do
      begin
        a:=p2[y];
        case s[y,x] of
          '+': d[x,0]:=d[x,0]+a;  (* Platz *)
          '#': d[x,1]:=d[x,1]+a;  (* Kiste *)
          '$': begin d[x,1]:=d[x,1]+a; d[x,0]:=d[x,0]+a end;
                                  (* Kiste auf Platz *)
          '|': d[x,2]:=d[x,2]+a;  (* Mauer *)
          '@': begin d[x,2]:=d[x,2]+a; d[x,1]:=d[x,1]+a end;
                                  (* Arbeiter *)
          '&': begin d[x,2]:=d[x,2]+a; d[x,1]:=d[x,1]+a; d[x,0]:=d[x,0]+a end;
                                  (* Arbeiter auf Platz *)
          ' ':                    (* frei *)
        end; (* case *)
      end (* for y *)
    end; (* for x *)
    seek(df,n-1);
    write(df,d);
  end; (* while *)
1:close(df);
  write(chr(13),k:3,' Ebenen fertig.');
  writeln;
end.
